///////////////////////////////////////////////////////////////////////////////
//
//	File - AJLPrototypes.h
//
//	Description -	Contains all of the declarations for the exported AJL Functions.
//
//	Copyright:  Axiohm Inc. 1997
//
////////////////////////////////////////////////////////////////////////////////
//
//	Edit History
//
//
/**	
** $History: ajlprototypes.h $
 * 
 * *****************  Version 7  *****************
 * User: Marty_bifaro Date: 2/01/99    Time: 2:39p
 * Updated in $/Common/User Mode Source/DLL
 * Added check flip support
 * 
 * *****************  Version 6  *****************
 * User: Marty_bifaro Date: 2/01/99    Time: 10:59a
 * Updated in $/Common/User Mode Source/DLL
 * Added panel button support for A758
 * 
 * *****************  Version 5  *****************
 * User: Marty_bifaro Date: 1/29/99    Time: 3:48p
 * Updated in $/Common/User Mode Source/DLL
 * Added support for full knife cut.
 * Version changed to 2.2
 * 
 * *****************  Version 24  *****************
 * User: Steve        Date: 4/28/98    Time: 5:05p
 * Updated in $/Source/axiohm/dll
 * Added code to support the A721 driver using conditional compiling.  The
 * #ifdefs are A721_PRINTER and A756_PRINTER
 * 
 * *****************  Version 23  *****************
 * User: Steve        Date: 4/24/98    Time: 4:54p
 * Updated in $/Source/axiohm/dll
 * Removed prototype AJL_MICR_ReadAndValidate
 * 
 * *****************  Version 22  *****************
 * User: Steve        Date: 4/23/98    Time: 4:21p
 * Updated in $/Source/axiohm/dll
 * Added prototype  AJL_CMD_SendRealTimePrinterStatus
 * 
 * *****************  Version 21  *****************
 * User: Steve        Date: 4/21/98    Time: 4:01p
 * Updated in $/Source/axiohm/dll
 * Added prototype for AJL_CMD_ResumePrinter
 * 
 * *****************  Version 20  *****************
 * User: Steve        Date: 4/20/98    Time: 3:07p
 * Updated in $/Source/axiohm/dll
 * Changed WriteRawData to support two parameters, cmd and data
 * 
 * *****************  Version 19  *****************
 * User: Steve        Date: 4/15/98    Time: 5:08p
 * Updated in $/Source/axiohm/dll
 * Add prototypes for real time requests and real time status
 * 
 * *****************  Version 18  *****************
 * User: Steve        Date: 4/15/98    Time: 1:45p
 * Updated in $/Source/axiohm/dll
 * Added two API's to select receipt and slip printers.
 * 
 * *****************  Version 17  *****************
 * User: Steve        Date: 4/09/98    Time: 10:39a
 * Updated in $/Source/axiohm/dll
 * Added API prototypes for read and write remote diagnostics
 * 
 * *****************  Version 16  *****************
 * User: Steve        Date: 4/03/98    Time: 4:26p
 * Updated in $/Source/axiohm/dll
 * Continuing modifications for A756
 * 
 * *****************  Version 15  *****************
 * User: Steve        Date: 4/02/98    Time: 5:04p
 * Updated in $/Source/axiohm/dll
 * Continue to make updates for A756
 * 
 * *****************  Version 14  *****************
 * User: Steve        Date: 4/01/98    Time: 5:15p
 * Updated in $/Source/axiohm/dll
 * Continuing modifications for A756
 * 
 * *****************  Version 13  *****************
 * User: Steve        Date: 3/31/98    Time: 5:13p
 * Updated in $/Source/axiohm/dll
 * Updates from A721 to A756 printer
 * 
 * *****************  Version 12  *****************
 * User: Steve        Date: 3/24/98    Time: 4:28p
 * Updated in $/Source/axiohm/dll
 * Original code from A721
 * 
 * *****************  Version 2  *****************
 * User: John         Date: 10/10/97   Time: 10:18a
 * Updated in $/Source/axiohm/dll
 * major cleanup
 * added notification, micr claim
 * 
 * *****************  Version 1  *****************
 * User: John         Date: 10/06/97   Time: 11:06a
 * Created in $/Source/App Interface DLL
 * initial entry

**/
//

extern "C"
{
__declspec( dllexport )AJLError				AJLSystem_Initialize(long * printerID, 
											 LPCSTR pPrinterName, 
											 LPCSTR pDeviceName, 
											 LPCSTR pPortName,
											 CEdit *pTextOutput);
};

extern "C"
{

__declspec( dllexport )AJLError			AJLSystem_IsInitializedAsync(long  printerID,
												 AJLResponseDataPTR pResponseData);
}

extern "C"
{
__declspec( dllexport )AJLError			AJLSystem_IsShuttingDownAsync(long  printerID,
												  AJLResponseDataPTR pResponseData);
};


extern "C"
{
__declspec( dllexport )AJLError				AJLSystem_Shutdown(const long printerID);
};

extern "C"
{
__declspec( dllexport )BOOL					AJLSystem_IsInitialized(const long printerID);
};

extern "C"
{
__declspec( dllexport )AJLError				AJLSystem_ClaimMICR(const long printerID,
																AJLResponseDataPTR pResponseData);
}

extern "C"
{
__declspec( dllexport )AJLError		AJLSystem_ReleaseMICR(const long printerID,
																AJLResponseDataPTR pResponseData);
}

extern "C"
{
__declspec( dllexport )AJLError	AJLSystem_RequestClaimedMICRNotification
									 (const long printerID,
									  AJLResponseDataPTR pResponseData,
									  BOOL notify);
}

extern "C"
{
__declspec( dllexport )AJLError				AJL_CMD_ResetPrinter(const long printerID);
};

extern "C"
{
__declspec( dllexport )AJLError				AJL_CMD_OpenCashDrawer(const long printerID);
};

extern "C"
{
__declspec( dllexport )AJLError				AJL_CMD_OpenCashDrawer2(const long printerID);
};

extern "C"
{
__declspec( dllexport )AJLError	 AJL_RT_SendRealTimeRequest(const long printerID,short nCmd);
};

extern "C"
{
__declspec( dllexport )AJLError	 AJL_CMD_WriteRawData(const long printerID,const char *ptrCmd, const char *ptrData);
};





extern "C"
{
__declspec( dllexport )AJLError				AJL_STAT_EASB(const long printerID, EASBType type, AJLResponseDataPTR pResponseData, BOOL setNotify);
};
										
extern "C"
{
__declspec( dllexport )short					AJL_STAT_GetModelID(const long printerID);
};

extern "C"
{
__declspec( dllexport )short					AJL_STAT_GetROMVersion(const long printerID);
};

extern "C"
{
__declspec( dllexport )short					AJL_STAT_GetTypeID(const long printerID);
};

extern "C"
{
__declspec( dllexport )AJLError				AJL_MICR_ReadAndEject(const long printerID,
												  AJLResponseDataPTR pResponseData);
};

extern "C"
{
__declspec( dllexport )AJLError				AJL_MICR_ReRead(const long printerID,
											AJLResponseDataPTR pResponseData);
};

#ifdef A721_PRINTER

extern "C"
{
__declspec( dllexport )AJLError				AJL_MICR_ReadAndValidate(const long printerID,
													 AJLResponseDataPTR pResponseData);
};

#endif


extern "C"
{
__declspec( dllexport )AJLError				AJL_MICR_ReadException(const long printerID,
												   AJLResponseDataPTR pResponseData, 
												   short exceptionAddress);
};
	
extern "C"
{
__declspec( dllexport )AJLError				AJL_MICR_SetCommandTimeout(const long printerID,
													   const long seconds);
};

extern "C"
{
__declspec( dllexport )AJLError				AJL_MICR_SetException(const long printerID,
												  short exceptionAddress,
												BYTE data1,
												BYTE data2);
};

extern "C"
{
__declspec( dllexport )AJLError				AJL_MICR_SetAndStoreParseParams(const long printerID,
															const char * paramstring);
};

extern "C"
{
__declspec( dllexport )AJLError				AJL_MICR_SetParseParams(const long printerID,
													const char * paramstring);
};

extern "C"
{
__declspec( dllexport )AJLError			AJL_STAT_GetCashDrawerStatus(const long printerID,
													 CashDrawerStatus * status);
}


extern "C"
{
__declspec( dllexport )AJLError			AJL_STAT_GetMechanicalErrorStatus(const long printerID,
														  BOOL * bMechanicalError);
};


extern "C"
{
__declspec( dllexport )AJLError			AJL_STAT_IsReceiptPaperLow(const long printerID,
												   BOOL * bReceiptPaperLow);
};

extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsSlipPaperSelected(const long printerID,
											 BOOL * bSelected);
}

extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsSlipPresent(const long printerID,
									   BOOL * bSlipPresent);
}

extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsSlipPaperPrintable(const long printerID,
											  BOOL * bIsPrintable);
}


extern "C"
{
__declspec( dllexport )AJLError  AJL_STAT_IsUnrecoverableError(const long printerID,
											BOOL * bError);
}


extern "C"
{
__declspec( dllexport )AJLError AJL_CMD_KnifeCut(const long printerID);
}

#ifdef A758_PRINTER
extern "C"
{
__declspec( dllexport )AJLError AJL_CMD_FullKnifeCut(const long printerID);
}

extern "C"
{
__declspec( dllexport )AJLError AJL_CMD_EnablePanelButtons(const long printerID);
}

extern "C"
{
__declspec( dllexport )AJLError AJL_CMD_DisablePanelButtons(const long printerID);
}

extern "C"
{
__declspec( dllexport )AJLError AJL_CMD_CheckFlip(const long printerID);
}
#endif

extern "C"
{
__declspec( dllexport )AJLError AJL_CMD_GenerateTone(const long printerID);
}


extern "C"
{
__declspec( dllexport )AJLError AJL_STAT_GetHeadOverTemperature(const long printerID,
												  BOOL * btempError);
}

extern "C"
{
__declspec( dllexport )AJLError AJL_STAT_GetKnifeStatus(const long printerID,
												  BOOL * bknifeError);
}

extern "C"
{
__declspec( dllexport )AJLError AJL_STAT_GetDoorStatus(const long printerID,
									  BOOL * bdoorStatus);
}


extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsSlipLeadingEdgePresent(const long printerID,
									   BOOL * bSlipPresent);
}

extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsSlipTrailingEdgePresent(const long printerID,
									   BOOL * bSlipPresent);
}

extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsReceiptPaperExhausted(const long printerID,
									   BOOL * bReceiptPaperExhausted);
}


extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsReceiptPaperLow(const long printerID,
										   BOOL * bReceiptPaperLow);
}


extern "C"
{
__declspec( dllexport )AJLError AJL_CMD_ReadRemoteDiagnostics(const long printerID,
						   CString paramString, 
						   AJLResponseDataPTR pResponseDatapResponseData);
}

extern "C"
{
__declspec( dllexport )AJLError AJL_CMD_WriteRemoteDiagnostics(const long printerID,
						   CString paramString);

}

extern "C"
{
__declspec( dllexport )AJLError	 AJL_CMD_SelectSlipStation(const long printerID);

}

extern "C"
{
__declspec( dllexport )AJLError	 AJL_CMD_SelectReceiptStation(const long printerID);

}


extern "C"
{
__declspec( dllexport )AJLError	 AJL_RT_SendRealTimeStatus(const long printerID,short nCmd,
											   AJLResponseDataPTR pResponseData);
}

extern "C"
{
__declspec( dllexport )AJLError	 AJL_RT_SendRealTimePrinterStatus(const long printerID,
											   AJLResponseDataPTR pResponseData);
}


extern "C"
{
__declspec( dllexport )AJLError  AJL_CMD_ResumePrinter(const long printerID);
}


#ifdef A721_PRINTER

extern "C"
{
__declspec( dllexport )AJLError			AJL_STAT_IsJournalPaperLow(const long printerID,
												   BOOL * bIsLow);
};

extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsValidationPresent(const long printerID,
											 BOOL * bValidationPresent);
}

extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsValidationSelected(const long printerID,
											  BOOL * bSelected);
}

extern "C"
{
__declspec( dllexport )AJLError	AJL_STAT_IsValidationPrintable(const long printerID,
											   BOOL * bPrintable);
}

#endif
